
// Helper for comgt

// © 2020 Jonas Bechtel
// Licensed under the Apache License, Version 2.0
//     see file <prj>/meta/NOTICE


#ifndef COMGT_HELPER
#define COMGT_HELPER

#include <stdlib.h> // size_t
#include <stdint.h> // uint8_t

// Like "man 3 strncpy" but
// * guarantees for \0 termination
// * doesn't fill rest with \0
// * returns the number of copied bytes (excluding final \0)
int strNcpy(char *dest, const char *src, size_t n)
#ifndef NOCODE
{
	if(dest == NULL || src == NULL) return 0;
	size_t i;
	for (i = 0; i < n-1 && src[i] != '\0'; i++)
		dest[i] = src[i];
	dest[i] = '\0';
	return i;
}
#endif // #ifndef NOCODE
;


// 'A' -> 10
// no error checking at all, will always succeed and return something
static uint8_t hexchar2int(char input) {
	input &= 0x5f;
	if (input & 0x40) input +=9;
	return input & 0x0f;
}

// "A1" -> 17
static uint8_t hexpair2int(char* input) {
	return (hexchar2int(input[0])<<4) | hexchar2int(input[1]);
}



// 10 -> 'A'
static char int2hexchar(uint8_t input) {
	if (input >= 10) return 'A'+input-10;
	return '0'+input;
}


#endif // #ifndef COMGT_HELPER


